#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <dirent.h>
#include <stdlib.h>
#include "cola.h"
#include "protocolo.h"

/*
   Lee a partir del directorio inicial de forma recursiva todos los archivos
   para introducirlos en una cola. Devuelve 1 si hay algun error.
*/
int leer_dir (char *dir_fuente, Cola *cola) {
   DIR *directorio;
   struct dirent *contenido;
   struct stat estado;
   char *path;
   int ok;

   directorio=opendir(dir_fuente);
   if (directorio==NULL) {
#ifdef DEBUG
      fprintf(stderr, "Error al acceder a %s", dir_fuente);
      perror(" ");
#endif
      return 1;
   }

   /* Saltamos el . y el .. inicial de todo directorio. 15 :? */
   seekdir(directorio, telldir(directorio)+15);

   /*  */
   while ((contenido=readdir(directorio))!=NULL ){
      path = (char *)malloc(sizeof(char)*BUFSIZ);
      snprintf(path, sizeof(char)*BUFSIZ, "%s/%s", dir_fuente, contenido->d_name);
      ok=stat(path, &estado);
      /* Comprobamos si se trata de un directorio */
      if ((estado.st_mode & S_IFMT) == S_IFDIR) {
         if (leer_dir(path, cola) == 1) {
            return 1;
         }
      } else {
         encolar(cola, path);
#ifdef DEBUG
	      fprintf(stderr, "%s\n", path);
#endif
      }
   }
   closedir(directorio);
   return 0;
}


// Prueba del funcionamiento de las funciones anteriores
/*int main (){
   Cola *cola = (Cola *)crear_cola();
   
   //leer_dir("/home/marbleman/universidad/xc1/practicas", cola);
   if (leer_dir("/tmp", cola) == 1) {
      fprintf(stderr, "Error!\n");
   }
   return 0;
}*/
