#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <malloc.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#include <sys/time.h>

#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gdk/gdkx.h>
#include <cola.h>
#include <protocolo.h>
#include <files.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "global.h"


void flush_pantalla (void)
{
  GdkDisplay *display = gdk_display_get_default ();
  XFlush (GDK_DISPLAY_XDISPLAY (display));
}

/**
   Destruye las ventanas contenidas en una lista y devuelve la nueva lista
   Su uso deberia ser: cola_win_buscar = destruir_ventanas(cola_win_buscar);
**/
GSList *destruir_ventanas(GSList *cola_win){
   guint total, i;
   GtkWidget *ventana;
   
   total = g_slist_length(cola_win);
   for (i=0; i<total; i++) {
      ventana = GTK_WIDGET(g_slist_nth_data(cola_win, i));
      // Destruir ventana
      gtk_widget_destroy (GTK_WIDGET(ventana));
   }
   g_slist_free_1(cola_win);
   cola_win = NULL;
   return cola_win;
}


/**
   Al pulsar conectar se muestra la ventana del nick
**/
void
conectar_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *win_nick;
   win_nick = create_win_nick ();
   gtk_widget_show (win_nick);
}

/**
   Al pulsar desconectar se deshabilitan ciertos botones, se da de baja del server
   y se para el demonio que atiende las peticiones de transferencias de archivos
   Adems se destruyen todas las ventanas existentes excepto la principal.
**/
void
desconectar_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   // Deshabilitar/habilitar botones
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_conectar")), TRUE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_desconectar")), FALSE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_buscar")), FALSE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_buscar_usuario")), FALSE);
   
   cola_win_buscar = destruir_ventanas(cola_win_buscar);
   cola_win_buscar_usuario = destruir_ventanas(cola_win_buscar_usuario);
   cola_win_buscar_usuario = destruir_ventanas(cola_win_descarga);
   
   Baja(sock, dir_socket_servidor, nick);
   close(sock);
   
   // Enviamos seal al demonio de transferencia de archivos para que pare
   kill(id_file_transfer_daemon, SIGINT);
   wait(&id_file_transfer_daemon);
   
   // Var. global
   conectado = 0;
   
   gtk_label_set(GTK_LABEL(lookup_widget (GTK_WIDGET (win_principal), "etiq_estado_principal")), "Estado: Desconectado");
}


/**
   Al pulsar buscar achivo se visualiza la ventana correspondiente
**/
void
buscar_clicked                         (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *win_buscar;
   
   win_buscar = create_win_buscar ();
   gtk_widget_show (win_buscar);
   cola_win_buscar = g_slist_append(cola_win_buscar, win_buscar);
}



/**
   Al pulsar buscar usuario se consulta al server los usuarios que hay para
   insertarlos en el listado de la ventana correspondiente.
   Se asocia la seal delete_event y el click en buscar, pasando por parametro
   una estructura con la lista con los resultados obtenidos (asi puede ser consultada
   y/o liberada).
**/
void
buscar_usuario_clicked                         (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *win_buscar_usuario = create_win_buscar_usuario ();
   GtkWidget *opcion_usuarios = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_buscar_usuario), "opcion_usuarios"));
   GtkWidget *menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_usuarios));
   GtkWidget *boton_efectuar_busqueda_usuarios = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_buscar_usuario), "boton_efectuar_busqueda_usuarios"));
   GtkWidget *item_nuevo;
   Cola *usuarios = crear_cola();
   char *nombre_usuario;
   int i;
   struct data *datos;
   
   Listar_usuarios(sock, dir_socket_servidor, nick, usuarios);
   
   reiniciar_PDI(usuarios);
   for (i=0; i< usuarios->total; i++) {
      nombre_usuario = (char *) obtener_elemento_PDI(usuarios);
      
      // Creamos un item en el listado por cada usuario encontrado
      item_nuevo = gtk_menu_item_new_with_mnemonic (nombre_usuario);
      gtk_widget_show (item_nuevo);
      gtk_container_add (GTK_CONTAINER (menu), item_nuevo);
      
      avanzar_PDI(usuarios);
   }
   
   
   datos = (struct data *)malloc(sizeof(struct data));
   datos->usuarios = usuarios;
   datos->archivos = NULL;
   gtk_signal_connect(GTK_OBJECT(win_buscar_usuario), "delete_event", GTK_SIGNAL_FUNC(cerrar_ventana_buscar_usuarios), datos);
   gtk_signal_connect ((gpointer) boton_efectuar_busqueda_usuarios, "clicked",
                    G_CALLBACK (busqueda_usuario_concreta_clicked),
                    datos);
   
   gtk_widget_show (win_buscar_usuario);
   cola_win_buscar_usuario = g_slist_append(cola_win_buscar_usuario, win_buscar_usuario);
}


/**
   Al pulsar buscar dentro de la ventana buscar usuario se consulta al servidor
   los ficheros de dicho usuario y se des/habilitan los botones necesarios.
**/
void busqueda_usuario_concreta_clicked(GtkButton *button, gpointer user_data) {
   GtkWidget *opcion_usuarios = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "opcion_usuarios"));
   GtkWidget *menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_usuarios));
   GtkWidget *item = gtk_menu_get_active (GTK_MENU(menu));
   GtkWidget *opcion_archivos2 = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "opcion_archivos2"));
   GtkWidget *menu_archivos = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_archivos2));
   GtkWidget *boton_descargar2 = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "boton_descargar2"));
   gint active_index = g_list_index (GTK_MENU_SHELL (menu)->children, item);
   struct data *datos = (struct data *) user_data;
   Cola *usuarios = datos->usuarios;
   Cola *resultados = crear_cola();
   char *nombre_usuario;
   GtkWidget *item_nuevo;
   int i;
   char *archivo;
   
   reiniciar_PDI(usuarios);
   for(i=0; i<active_index; i++) {
      avanzar_PDI(usuarios);
   }
   nombre_usuario = (char *) obtener_elemento_PDI(usuarios);
   // Si no encuentra nada
   if (Listar_archivos_cliente(sock, dir_socket_servidor, nick, nombre_usuario, resultados) == 2) {
      item_nuevo = gtk_menu_item_new_with_mnemonic ("Ningun archivo encontrado");
      gtk_widget_show (item_nuevo);
      gtk_container_add (GTK_CONTAINER (menu_archivos), item_nuevo);
      
      gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_usuarios), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivos2), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar2), FALSE);
   } else { // Si hay resultados
      reiniciar_PDI(resultados);
      for (i=0; i< resultados->total; i++) {
         archivo = (char *) obtener_elemento_PDI(resultados);
         
         // Creamos un item en el listado por cada archivo encontrado
         item_nuevo = gtk_menu_item_new_with_mnemonic (archivo);
         gtk_widget_show (item_nuevo);
         gtk_container_add (GTK_CONTAINER (menu_archivos), item_nuevo);
         
         avanzar_PDI(resultados);
      }
      
      datos->archivos = resultados;
      
      g_signal_connect ((gpointer) boton_descargar2, "clicked",
                       G_CALLBACK (descargar2_clicked),
                       datos);
                       
      gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_usuarios), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivos2), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar2), TRUE);
   }
}


/**
   Al pulsar buscar dentro de la ventana buscar archivo se consulta al servidor
   los ficheros que contiene la cadena de texto que hay en el entry 
   y se des/habilitan los botones necesarios.
   ** En user_data recibimos el id de la seal asociada a delete_event de la ventana
   ** tal y como hemos indicado en interfaz.c, esto nos permite desconectar esa seal
   ** para substituirla por otra
**/
void
busqueda_concreta_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   int i;
   GtkWidget *entrada_archivo = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "entrada_archivo"));
   char *texto = (char *)gtk_entry_get_text(GTK_ENTRY(entrada_archivo));
   GtkWidget *win_buscar = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "win_buscar"));
   GtkWidget *boton_descargar = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "boton_descargar"));
   GtkWidget *opcion_archivo = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "opcion_archivo"));
   GtkWidget *menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_archivo));
   GtkWidget *item = gtk_menu_get_active (GTK_MENU(menu));
   GtkWidget *item_nuevo;
   char *texto_item;
   struct TRegistroCompartido *archivo;
   
                    
   Cola *resultados = crear_cola();
   // Si no encuentra nada
   if (Buscar_archivo(sock, dir_socket_servidor, nick, texto, resultados) == 2) {
      item_nuevo = gtk_menu_item_new_with_mnemonic ("Ningun archivo encontrado");
      gtk_widget_show (item_nuevo);
      gtk_container_add (GTK_CONTAINER (menu), item_nuevo);
      
      gtk_widget_set_sensitive(GTK_WIDGET(entrada_archivo), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivo), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar), FALSE);
   } else { // Si hay resultados
      reiniciar_PDI(resultados);
      for (i=0; i< resultados->total; i++) {
         archivo = (struct TRegistroCompartido *) obtener_elemento_PDI(resultados);
         
         // Creamos un item en el listado por cada archivo encontrado
         // El texto estara compuesto por "usuario ::: archivo"
         texto_item = (char *)malloc(sizeof(archivo->archivo) + sizeof(archivo->nick) + 10);
         snprintf(texto_item, sizeof(archivo->archivo) + sizeof(archivo->nick) + 10, "%s ::: %s", archivo->nick, archivo->archivo);
         item_nuevo = gtk_menu_item_new_with_mnemonic (texto_item);
         gtk_widget_show (item_nuevo);
         gtk_container_add (GTK_CONTAINER (menu), item_nuevo);
         
         avanzar_PDI(resultados);
      }

      g_signal_connect ((gpointer) boton_descargar, "clicked",
                       G_CALLBACK (descargar_clicked),
                       resultados);
      // Reemplazamos la seal delete_event por otra que libere la cola resultados
      gtk_signal_disconnect(win_buscar, (int)user_data);
      gtk_signal_connect(GTK_OBJECT(win_buscar), "delete_event", GTK_SIGNAL_FUNC(cerrar_ventana_buscar), resultados);
      
      gtk_widget_set_sensitive(GTK_WIDGET(entrada_archivo), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
      gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivo), TRUE);
      gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar), TRUE);
   }
}


/**
   Al pulsar descargar de la ventana buscar archivo se destruye dicha ventana y se
   realiza la peticin para descargar. Liberamos tb los resultados anteriormente
   obtenidos.
**/
void
descargar_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   Cola *resultados = (Cola *) user_data;
   GtkWidget *win_descarga;
   GtkWidget *etiq_archivo;
   char *texto_etiq;
   GtkWidget *etiq_estado_descarga;
   GtkWidget *win_buscar = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "win_buscar"));
   GtkWidget *opcion_archivo = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "opcion_archivo"));
   GtkWidget *menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_archivo));
   GtkWidget *item = gtk_menu_get_active (GTK_MENU(menu));
   gint active_index = g_list_index (GTK_MENU_SHELL (menu)->children, item);
   GtkWidget *boton_descarga_finalizada;
   GtkWidget *barra_progreso;
   struct TRegistroCompartido *archivo;
   struct TRegistroCliente info_nick;
   int i;

   
   reiniciar_PDI(resultados);
   for(i=0; i<active_index; i++) {
      avanzar_PDI(resultados);
   }
   archivo = (struct TRegistroCompartido *) obtener_elemento_PDI(resultados);
   
   // Se elimina la ventana de busqueda
   cola_win_buscar = g_slist_remove(cola_win_buscar, win_buscar);
   gtk_widget_destroy (GTK_WIDGET(win_buscar));
   
   //Realizamos la descarga en forma de thread
   struct peticion *peticion_archivo = (struct peticion *)malloc(sizeof(struct peticion));
   snprintf(peticion_archivo->nick, TAM_NICKS, "%s", archivo->nick);
   snprintf(peticion_archivo->archivo, TAM_NOMBRE_ARCHIVO, "%s", archivo->archivo);
   g_thread_create (bajar_archivo, (gpointer)peticion_archivo, FALSE, NULL);
   
   vaciar_cola(resultados);
}


/**
   Al pulsar descargar de la ventana buscar usuarios se destruye dicha ventana y se
   realiza la peticin para descargar. Liberamos tb los resultados anteriormente
   obtenidos.
**/
void
descargar2_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
   struct data *datos = (struct data *) user_data;
   Cola *resultados = datos->archivos;
   Cola *usuarios = datos->usuarios;
   GtkWidget *win_buscar_usuario = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "win_buscar_usuario"));
   GtkWidget *opcion_archivo2 = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "opcion_archivos2"));
   GtkWidget *menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(opcion_archivo2));
   GtkWidget *item = gtk_menu_get_active (GTK_MENU(menu));
   gint active_index = g_list_index (GTK_MENU_SHELL (menu)->children, item);
   
   char *archivo;
   char *nombre_usuario;
   int i;
   
   
   reiniciar_PDI(resultados);
   for(i=0; i<active_index; i++) {
      avanzar_PDI(resultados);
   }
   archivo = (char *) obtener_elemento_PDI(resultados);
   // El pdi de usuario esta apuntando al usuario correcto
   nombre_usuario = (char *) obtener_elemento_PDI(usuarios);
   
   // Se elimina la ventana de busqueda
   cola_win_buscar_usuario = g_slist_remove(cola_win_buscar_usuario, win_buscar_usuario);
   gtk_widget_destroy (GTK_WIDGET(win_buscar_usuario));

   //Realizamos la descarga en forma de thread
   struct peticion *peticion_archivo = (struct peticion *)malloc(sizeof(struct peticion));
   snprintf(peticion_archivo->nick, TAM_NICKS, "%s", nombre_usuario);
   snprintf(peticion_archivo->archivo, TAM_NOMBRE_ARCHIVO, "%s", archivo);
   g_thread_create (bajar_archivo, (gpointer)peticion_archivo, FALSE, NULL);

   vaciar_cola(resultados);
   vaciar_cola(usuarios);
   free(datos);
}

/**
   Baja el archivo indicado del usuario indicado. Solicita informacin al servidor
   sobre el usuario en concreto y se conecta con este para realizar la peticin.
   Por pantalla visualiza la ventana de descarga.
   Se ejecutara como thread.
**/
gpointer bajar_archivo(gpointer data){
   struct peticion *peticion_archivo = (struct peticion *) data;
   char *nick = peticion_archivo->nick;
   char *archivo = peticion_archivo->archivo;
   GtkWidget *boton_descarga_finalizada;
   GtkWidget *barra_progreso;
   GtkWidget *win_descarga;
   GtkWidget *etiq_archivo;
   char *texto_etiq;
   GtkWidget *etiq_estado_descarga;
   struct TRegistroCliente info_nick;
   float time;
   struct timeval now, then;
   char velocidad[BUFSIZ];
   ///
   int sockfd, bytes;  
   char buffer[BUFSIZ];
   struct hostent *he;
   struct sockaddr_in their_addr; 
   char *ptr;
   char archivo_local[TAM_NOMBRE_ARCHIVO] = "incoming";
   int archivofd, bytes_totales, bytes_descargados=0;
   int bytes_a_leer;
   ///

   Consultar_datos_cliente(sock, dir_socket_servidor, nick, nick, &info_nick); 
   
   gdk_threads_enter();
   // Creamos ventana de descarga
   win_descarga = create_win_descarga (); // No encolar la ventana hasta que haya terminado
   
   // Modificamos las etiquetas
   etiq_archivo = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_descarga), "etiq_archivo"));
   etiq_estado_descarga = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_descarga), "etiq_estado_descarga"));
   // El texto estara compuesto por "usuario ::: archivo"
   texto_etiq = (char *)malloc(strlen(archivo) + strlen(nick) + 25);
   snprintf(texto_etiq, strlen(archivo) + strlen(nick) + 25, "Usuario: %s - Archivo: %s", nick, archivo);
   gtk_label_set(GTK_LABEL(etiq_archivo), texto_etiq);
   // Barra de progreso
   barra_progreso = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_descarga), "barra_progreso"));
   // Boton
   boton_descarga_finalizada = GTK_WIDGET(lookup_widget (GTK_WIDGET (win_descarga), "boton_descarga_finalizada"));
   // Mostramos ventana
   gtk_widget_show (win_descarga);
   gdk_flush ();
   gdk_threads_leave();
   
   ///////////////////
   // PEDIR ARCHIVO //
   ///////////////////
   if ((he=gethostbyname(info_nick.ip)) == NULL) { 
     perror("gethostbyname");
     exit(1);
   }
   
   if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
     perror("socket");
     exit(1);
   }
   
   their_addr.sin_family = AF_INET;    // host byte order 
   their_addr.sin_port = htons(atoi(info_nick.puerto));  // short, network byte order 
   their_addr.sin_addr = *((struct in_addr *)he->h_addr);
   memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct 
   
   if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
     perror("connect");
     gdk_threads_enter();
     gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Imposible conectar!");
     gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
     gdk_flush ();
     gdk_threads_leave();
     cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
     return;
   }
   
   // Enviamos archivo que solicitamos
   if (send(sockfd, archivo, TAM_NOMBRE_ARCHIVO, 0) == -1) {
    perror("send");
    gdk_threads_enter();
    gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Imposible enviar peticin!");
    gdk_flush ();
    gdk_threads_leave();
   }
   
   // Recibimos Tamao
   if ((bytes=recv(sockfd, buffer, sizeof buffer, 0)) == -1) {
     perror("recv");
     gdk_threads_enter();
     gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Error al recibir!");
     gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
     gdk_flush ();
     gdk_threads_leave();
     cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
     return;
   }
   // El archivo solicitado no ha sido encontrado
   if (strcmp(buffer, "Not Found\n")==0) {
     gdk_threads_enter();
     gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Archivo no encontrado!");
     gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
     gdk_flush ();
     gdk_threads_leave();
     cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
     return;
   }
   bytes_totales = atoi(buffer);

   // Coger solo el nombre del fichero que descargamos, descartamos el directorio
   // donde esta guardado en la mquina remota
   ptr = strrchr(archivo, '/');
   // Construimos "incoming/nombre_del_archivo" para guardar en ese directorio
   strncat(archivo_local, ptr, TAM_NOMBRE_ARCHIVO- sizeof("incoming"));
   
   // Creamos archivo, si existe se sobreescribe.
   if ((archivofd = open(archivo_local, O_WRONLY|O_TRUNC|O_CREAT, 0666)) == -1) {
    perror("Error al crear archivo");
    gdk_threads_enter();
    gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Error al crear archivo en incoming/!");
    gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
    gdk_flush ();
    gdk_threads_leave();
    cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
    return;
   }
   
   
   //////
   // Recibimos los primeros bytes, debemos comprobar que no se nos devuelva
   // un not found por error al abrirlo en el servidor.
   if (bytes_totales - bytes_descargados <= sizeof(buffer)) {
      bytes_a_leer = bytes_totales - bytes_descargados;
   } else {
      bytes_a_leer = sizeof(buffer);
   }
    
   // Guardamos el tiempo en el que se inicia la descarga
   // Nos servir para calcular los KB/s (velocidad)
   bzero(&then,sizeof(then));
   gettimeofday(&then,NULL);
   
     
   //if ((bytes=recv(sockfd, buffer, bytes_a_leer, MSG_WAITALL)) == -1) {
   if ((bytes=read(sockfd, buffer, bytes_a_leer)) == -1) {
     perror("recv");
     close(archivofd);
     gdk_threads_enter();
     gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Error al recibir!");
     gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
     gdk_flush ();
     gdk_threads_leave();
     cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
     return;
   }

   // El archivo solicitado no ha sido encontrado
   if (strcmp(buffer, "Not Found\n")==0) {
     gdk_threads_enter();
     gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Archivo no encontrado!");
     gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
     gdk_flush ();
     gdk_threads_leave();
     cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
     return;
   }

   bytes_descargados += bytes;

   // Calcular el % y los KB/s de la descarga
   bzero(&now,sizeof(now));
   gettimeofday(&now,NULL);
   /* sec + nano sec/1.000.000 */
   time = ((now.tv_sec - then.tv_sec)*1.0f + (now.tv_usec - then.tv_usec)/1000000.0f);
   snprintf(velocidad, BUFSIZ, "Descargando %3d%% (%5uK/%5uK) @ %.2f KB/s ", (int)((float)bytes_descargados/(float)bytes_totales*100), bytes_descargados/1024, bytes_totales/1024, bytes_descargados/(1024*time));
   //
   
   // Actualizamos barra de progreso
   if ((bytes_totales==0) && (bytes_descargados == 0)) {
      gdk_threads_enter();
      gtk_label_set(GTK_LABEL(etiq_estado_descarga), velocidad);
      gtk_progress_set_percentage(GTK_PROGRESS(barra_progreso), 1.0);
      gdk_flush ();
      gdk_threads_leave();
   } else {
      gdk_threads_enter();
      gtk_progress_set_percentage(GTK_PROGRESS(barra_progreso), (float)(bytes_descargados)/(float)(bytes_totales));
      gdk_flush ();
      gdk_threads_leave();
   }
   
   write(archivofd, buffer, bytes);
   //////
   
   // Recibimos el resto del archivo
   while (bytes_descargados < bytes_totales) {
      if (bytes_totales - bytes_descargados <= sizeof(buffer)) {
         bytes_a_leer = bytes_totales - bytes_descargados;
      } else {
         bytes_a_leer = sizeof(buffer);
      }
      //if ((bytes=recv(sockfd, buffer, bytes_a_leer, MSG_WAITALL)) == -1) {
      if ((bytes=read(sockfd, buffer, bytes_a_leer)) == -1) {
         perror("recv");
         close(archivofd);
         gdk_threads_enter();
         gtk_label_set(GTK_LABEL(etiq_estado_descarga), "Error al recibir!");
         gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
         gdk_flush ();
         gdk_threads_leave();
         cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
         return;
      }
      
      // Calcular el % y los KB/s de la descarga
      bzero(&now,sizeof(now));
      gettimeofday(&now,NULL);
      /* sec + nano sec/1.000.000 */
      time = ((now.tv_sec - then.tv_sec)*1.0f + (now.tv_usec - then.tv_usec)/1000000.0f);
      snprintf(velocidad, BUFSIZ, "Descargando %3d%% (%uK/%uK) @ %.2f KB/s ", (int)((float)bytes_descargados/(float)bytes_totales*100), bytes_descargados/1024, bytes_totales/1024, bytes_descargados/(1024*time));
      //
      
      bytes_descargados += bytes;
      gdk_threads_enter();
      gtk_label_set(GTK_LABEL(etiq_estado_descarga), velocidad);
      // Actualizamos barra de progreso
      gtk_progress_set_percentage(GTK_PROGRESS(barra_progreso), (float)(bytes_descargados)/(float)(bytes_totales));
      gdk_flush ();
      gdk_threads_leave();
      write(archivofd, buffer, bytes);
   }
   //////
   
   close(sockfd);
   close(archivofd);
   ///////////////////////
   // FIN PEDIR ARCHIVO //
   ///////////////////////
   free(peticion_archivo);
   gdk_threads_enter();
   // Dejar impresa la informacin estadistica final
   snprintf(velocidad, BUFSIZ, "Descargado! %3d%% (%uK/%uK) @ %.2f KB/s ", (int)((float)bytes_descargados/(float)bytes_totales*100), bytes_descargados/1024, bytes_totales/1024, bytes_descargados/(1024*time));
   gtk_label_set(GTK_LABEL(etiq_estado_descarga), velocidad);
   gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), TRUE);
   gdk_flush ();
   gdk_threads_leave();
   cola_win_descarga = g_slist_append(cola_win_descarga, win_descarga);
}


/**
   Al pulsar aceptar de la ventana de nick se realiza la conexion con el servidor.
   Se obtienen el nick, server y puerto al que nos queremos conectar de las entradas
   de la ventana.
   Nos damos de alta en el servidor y compartimos todos nuestros ficheros.
   Habilitamos los botones que ahora si tienen funcionalidad.
**/
void
nick_clicked                           (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *entrada_nick = lookup_widget (GTK_WIDGET (button), "entrada_nick");
   GtkWidget *entrada_server = lookup_widget (GTK_WIDGET (button), "entrada_server");
   GtkWidget *entrada_puerto = lookup_widget (GTK_WIDGET (button), "entrada_puerto");
   unsigned int puerto_filetransfer;
   
   // Si se ha dejado algo en blanco no lo aceptamos
   if ((strcmp(gtk_entry_get_text(GTK_ENTRY(entrada_nick)), "") == 0) ||
      (strcmp(gtk_entry_get_text(GTK_ENTRY(entrada_server)), "") == 0) ||
      (strcmp(gtk_entry_get_text(GTK_ENTRY(entrada_puerto)), "") == 0)) {
      return;
   }
   
   // Si algun campo contiene un espacio no lo aceptamos
   if ((strchr(gtk_entry_get_text(GTK_ENTRY(entrada_nick)), ' ') != NULL) ||
      (strchr(gtk_entry_get_text(GTK_ENTRY(entrada_server)), ' ') != NULL) ||
      (strchr(gtk_entry_get_text(GTK_ENTRY(entrada_puerto)), ' ') != NULL)){
         return;
   }
   
   // Copiamos el contenido de la caja de texto a la var. nick
   snprintf(nick, TAM_NICKS, "%s", (char *)gtk_entry_get_text(GTK_ENTRY(entrada_nick)));
   
   // Inicializamos el socket para la peticiones de archivos de otros clientes
   // Nos devuelve el puerto por donde escuchamos
   puerto_filetransfer = file_transfer_socket();
   // Demonio que atiende peticiones de transferencia de archivos
   // Guardamos su ID en una variable global
   id_file_transfer_daemon = fork();
   if (!id_file_transfer_daemon) {  // Hijo
      file_transfer_daemon(ficheros_compartidos);
   }
   
   crear_socket(gtk_entry_get_text(GTK_ENTRY(entrada_server)), atoi(gtk_entry_get_text(GTK_ENTRY(entrada_puerto))), &sock, &dir_socket_servidor);
   
   Alta(sock, dir_socket_servidor, nick, puerto_filetransfer);
   // Var. global
   conectado = 1;
   
   CompartirFicheros(sock, dir_socket_servidor, nick, ficheros_compartidos);
   
   // Destruir ventana de nick
   gtk_widget_destroy (GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "win_nick")));
   // Deshabilitar/habilitar botones
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_conectar")), FALSE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_desconectar")), TRUE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_buscar")), TRUE);
   gtk_widget_set_sensitive(GTK_WIDGET(lookup_widget (GTK_WIDGET (win_principal), "boton_buscar_usuario")), TRUE);
   
   char *estado = (char *)malloc(sizeof("Estado: Conectado con []") + strlen(nick)+1);
   snprintf(estado,sizeof("Estado: Conectado con nick ") + strlen(nick) +1, "Estado: Conectado [%s]", nick);
   gtk_label_set(GTK_LABEL(lookup_widget (GTK_WIDGET (win_principal), "etiq_estado_principal")), estado);
}


/**
   Funcion generica normalmente asociada a la seal delete_event de las ventanas.
   Elimina la ventana de la cola de ventanas y la destruye.
**/
void cerrar_ventana (GtkWindow *window, gpointer user_data){
   
   // Se eliminar de la cola a la que pertenezca
   cola_win_buscar = g_slist_remove(cola_win_buscar, window);
   cola_win_buscar_usuario = g_slist_remove(cola_win_buscar_usuario, window);
   cola_win_descarga = g_slist_remove(cola_win_descarga, window);
   
   gtk_widget_destroy (GTK_WIDGET(window));
   
}

/**
   Impide cerrar la ventana. Normalmente asociado al delete_event de las ventanas.
**/
void no_cerrar_ventana (GtkWindow *window, gpointer user_data){
   gtk_widget_show(GTK_WIDGET(window));
}


/**
   Tratamiento especial del cierre de la ventana buscar archivo ya que debe
   liberarse los resultados obtenidos que son pasados por user_data.
**/
void cerrar_ventana_buscar(GtkWindow *window, gpointer user_data) {
   vaciar_cola((Cola *)user_data);
   cola_win_buscar = g_slist_remove(cola_win_buscar, window);
   gtk_widget_destroy (GTK_WIDGET(window));
}


/**
   Tratamiento especial del cierre de la ventana buscar usuario ya que debe
   liberarse los resultados obtenidos que son pasados por user_data.
**/
void cerrar_ventana_buscar_usuarios(GtkWindow *window, gpointer user_data) {
   struct data *datos = (struct data *) user_data;
   Cola *resultados = datos->archivos;
   Cola *usuarios = datos->usuarios;

   cola_win_buscar = g_slist_remove(cola_win_buscar, window);
   gtk_widget_destroy (GTK_WIDGET(window));
   
   vaciar_cola(resultados);
   vaciar_cola(usuarios);
   free(datos);
}


/**
   Al pulsar aceptar en la ventana de descarga de archivos se elimina esta de
   la cola de ventanas y se destruye.
**/
void descarga_finalizada_clicked (GtkWidget *button, gpointer user_data){
   GtkWidget *window = GTK_WIDGET(lookup_widget (GTK_WIDGET (button), "win_descarga"));;
   cola_win_descarga = g_slist_remove(cola_win_descarga, window);
   gtk_widget_destroy (GTK_WIDGET(window));
}


/**
   Al pulsar salir de la ventana principal se desconecta del server y elimina el
   demonio que atiende peticiones de transferencia de archivos en caso de que este
   conectado. Finalmente termina la aplicacin.
**/
void salir_clicked (GtkWindow *button, gpointer user_data){
   if (conectado) {
      Baja(sock, dir_socket_servidor, nick);
      close(sock);
      // Enviamos seal al demonio de transferencia de archivos para que pare
      kill(id_file_transfer_daemon, SIGINT);
      wait(&id_file_transfer_daemon);
      // Var. global
      conectado = 0;
   }
   gtk_main_quit();
}



