#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include <protocolo.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)


/**
   Ventana principal
**/
GtkWidget*
create_win_principal (void)
{
  GtkWidget *win_principal;
  GtkWidget *fixed1;
  GtkWidget *boton_conectar;
  GtkWidget *alignment1;
  GtkWidget *hbox1;
  GtkWidget *image1;
  GtkWidget *label1;
  GtkWidget *boton_desconectar;
  GtkWidget *alignment6;
  GtkWidget *hbox6;
  GtkWidget *image6;
  GtkWidget *label8;
  GtkWidget *etiq_estado_principal;
  GtkWidget *boton_buscar_usuario;
  GtkWidget *alignment7;
  GtkWidget *hbox7;
  GtkWidget *image7;
  GtkWidget *label9;
  GtkWidget *boton_buscar;
  GtkWidget *alignment4;
  GtkWidget *hbox4;
  GtkWidget *image4;
  GtkWidget *label5;
  GtkWidget *boton_salir;
  GtkWidget *alignment3;
  GtkWidget *hbox3;
  GtkWidget *image3;
  GtkWidget *label4;

  win_principal = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win_principal), 5);
  gtk_window_set_title (GTK_WINDOW (win_principal), "Hamster");

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (win_principal), fixed1);

  boton_conectar = gtk_button_new ();
  gtk_widget_show (boton_conectar);
  gtk_fixed_put (GTK_FIXED (fixed1), boton_conectar, 8, 16);
  gtk_widget_set_size_request (boton_conectar, 104, 32);

  alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment1);
  gtk_container_add (GTK_CONTAINER (boton_conectar), alignment1);

  hbox1 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (alignment1), hbox1);

  image1 = gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox1), image1, FALSE, FALSE, 0);

  label1 = gtk_label_new_with_mnemonic ("Conectar");
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

  boton_desconectar = gtk_button_new ();
  gtk_widget_show (boton_desconectar);
  gtk_fixed_put (GTK_FIXED (fixed1), boton_desconectar, 8, 56);
  gtk_widget_set_size_request (boton_desconectar, 104, 32);
  gtk_widget_set_sensitive(GTK_WIDGET(boton_desconectar), FALSE);
  
  alignment6 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment6);
  gtk_container_add (GTK_CONTAINER (boton_desconectar), alignment6);

  hbox6 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER (alignment6), hbox6);

  image6 = gtk_image_new_from_stock ("gtk-cancel", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image6);
  gtk_box_pack_start (GTK_BOX (hbox6), image6, FALSE, FALSE, 0);

  label8 = gtk_label_new_with_mnemonic ("Desconectar");
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (hbox6), label8, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

  etiq_estado_principal = gtk_label_new ("Estado: Desconectado");
  gtk_widget_show (etiq_estado_principal);
  gtk_fixed_put (GTK_FIXED (fixed1), etiq_estado_principal, 8, 96);
  gtk_widget_set_size_request (etiq_estado_principal, 320, 24);
  gtk_label_set_justify (GTK_LABEL (etiq_estado_principal), GTK_JUSTIFY_LEFT);

  boton_buscar_usuario = gtk_button_new ();
  gtk_widget_show (boton_buscar_usuario);
  gtk_fixed_put (GTK_FIXED (fixed1), boton_buscar_usuario, 128, 56);
  gtk_widget_set_size_request (boton_buscar_usuario, 128, 32);
  gtk_widget_set_sensitive(GTK_WIDGET(boton_buscar_usuario), FALSE);

  alignment7 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment7);
  gtk_container_add (GTK_CONTAINER (boton_buscar_usuario), alignment7);

  hbox7 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (alignment7), hbox7);

  image7 = gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image7);
  gtk_box_pack_start (GTK_BOX (hbox7), image7, FALSE, FALSE, 0);

  label9 = gtk_label_new_with_mnemonic ("Buscar usuario");
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox7), label9, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

  boton_buscar = gtk_button_new ();
  gtk_widget_show (boton_buscar);
  gtk_fixed_put (GTK_FIXED (fixed1), boton_buscar, 128, 16);
  gtk_widget_set_size_request (boton_buscar, 128, 32);
  gtk_widget_set_sensitive(GTK_WIDGET(boton_buscar), FALSE);

  alignment4 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment4);
  gtk_container_add (GTK_CONTAINER (boton_buscar), alignment4);

  hbox4 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (alignment4), hbox4);

  image4 = gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image4);
  gtk_box_pack_start (GTK_BOX (hbox4), image4, FALSE, FALSE, 0);

  label5 = gtk_label_new_with_mnemonic ("Buscar archivo");
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox4), label5, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);

  boton_salir = gtk_button_new ();
  gtk_widget_show (boton_salir);
  gtk_fixed_put (GTK_FIXED (fixed1), boton_salir, 272, 16);
  gtk_widget_set_size_request (boton_salir, 72, 72);

  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (boton_salir), alignment3);

  hbox3 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox3);

  image3 = gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image3);
  gtk_box_pack_start (GTK_BOX (hbox3), image3, FALSE, FALSE, 0);

  label4 = gtk_label_new_with_mnemonic ("Salir");
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox3), label4, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

  // Cuando cierre la ventana se cierra la aplicacion
  gtk_signal_connect(GTK_OBJECT(win_principal), "delete_event", GTK_SIGNAL_FUNC(salir_clicked), NULL);
  
  g_signal_connect ((gpointer) boton_conectar, "clicked",
                    G_CALLBACK (conectar_clicked),
                    NULL);
  g_signal_connect ((gpointer) boton_desconectar, "clicked",
                    G_CALLBACK (desconectar_clicked),
                    NULL);
  g_signal_connect ((gpointer) boton_buscar_usuario, "clicked",
                    G_CALLBACK (buscar_usuario_clicked),
                    NULL);
  g_signal_connect ((gpointer) boton_buscar, "clicked",
                    G_CALLBACK (buscar_clicked),
                    NULL);
  g_signal_connect ((gpointer) boton_salir, "clicked",
                    G_CALLBACK (salir_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_principal, win_principal, "win_principal");
  GLADE_HOOKUP_OBJECT (win_principal, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (win_principal, boton_conectar, "boton_conectar");
  GLADE_HOOKUP_OBJECT (win_principal, alignment1, "alignment1");
  GLADE_HOOKUP_OBJECT (win_principal, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (win_principal, image1, "image1");
  GLADE_HOOKUP_OBJECT (win_principal, label1, "label1");
  GLADE_HOOKUP_OBJECT (win_principal, boton_desconectar, "boton_desconectar");
  GLADE_HOOKUP_OBJECT (win_principal, alignment6, "alignment6");
  GLADE_HOOKUP_OBJECT (win_principal, hbox6, "hbox6");
  GLADE_HOOKUP_OBJECT (win_principal, image6, "image6");
  GLADE_HOOKUP_OBJECT (win_principal, label8, "label8");
  GLADE_HOOKUP_OBJECT (win_principal, etiq_estado_principal, "etiq_estado_principal");
  GLADE_HOOKUP_OBJECT (win_principal, boton_buscar_usuario, "boton_buscar_usuario");
  GLADE_HOOKUP_OBJECT (win_principal, alignment7, "alignment7");
  GLADE_HOOKUP_OBJECT (win_principal, hbox7, "hbox7");
  GLADE_HOOKUP_OBJECT (win_principal, image7, "image7");
  GLADE_HOOKUP_OBJECT (win_principal, label9, "label9");
  GLADE_HOOKUP_OBJECT (win_principal, boton_buscar, "boton_buscar");
  GLADE_HOOKUP_OBJECT (win_principal, alignment4, "alignment4");
  GLADE_HOOKUP_OBJECT (win_principal, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (win_principal, image4, "image4");
  GLADE_HOOKUP_OBJECT (win_principal, label5, "label5");
  GLADE_HOOKUP_OBJECT (win_principal, boton_salir, "boton_salir");
  GLADE_HOOKUP_OBJECT (win_principal, alignment3, "alignment3");
  GLADE_HOOKUP_OBJECT (win_principal, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (win_principal, image3, "image3");
  GLADE_HOOKUP_OBJECT (win_principal, label4, "label4");

  return win_principal;
}

/**
   Ventana buscar archivos
**/
GtkWidget*
create_win_buscar (void)
{
  GtkWidget *win_buscar;
  GtkWidget *fixed2;
  GtkWidget *entrada_archivo;
  GtkWidget *label6;
  GtkWidget *boton_efectuar_busqueda;
  GtkWidget *alignment5;
  GtkWidget *hbox5;
  GtkWidget *image5;
  GtkWidget *label7;
  GtkWidget *label11;
  GtkWidget *opcion_archivo;
  GtkWidget *boton_descargar;
  GtkWidget *alignment8;
  GtkWidget *hbox8;
  GtkWidget *image8;
  GtkWidget *label10;
  GtkWidget *menu1;
  GtkWidget *uno1;
  GtkWidget *dos1;


  win_buscar = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win_buscar), 5);
  gtk_window_set_title (GTK_WINDOW (win_buscar), "Busqueda de archivos");

  fixed2 = gtk_fixed_new ();
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (win_buscar), fixed2);

  entrada_archivo = gtk_entry_new ();
  gtk_widget_show (entrada_archivo);
  gtk_fixed_put (GTK_FIXED (fixed2), entrada_archivo, 16, 32);
  gtk_widget_set_size_request (entrada_archivo, 158, 22);
  gtk_entry_set_max_length (GTK_ENTRY (entrada_archivo), 200);
  gtk_entry_set_activates_default (GTK_ENTRY (entrada_archivo), TRUE);

  label6 = gtk_label_new ("Archivo:");
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (fixed2), label6, 8, 8);
  gtk_widget_set_size_request (label6, 56, 16);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);

  boton_efectuar_busqueda = gtk_button_new ();
  gtk_widget_show (boton_efectuar_busqueda);
  gtk_fixed_put (GTK_FIXED (fixed2), boton_efectuar_busqueda, 192, 8);
  gtk_widget_set_size_request (boton_efectuar_busqueda, 80, 48);

  alignment5 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment5);
  gtk_container_add (GTK_CONTAINER (boton_efectuar_busqueda), alignment5);

  hbox5 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (alignment5), hbox5);

  image5 = gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image5);
  gtk_box_pack_start (GTK_BOX (hbox5), image5, FALSE, FALSE, 0);

  label7 = gtk_label_new_with_mnemonic ("Buscar");
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (hbox5), label7, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  label11 = gtk_label_new ("Seleccionar archivo a descargar");
  gtk_widget_show (label11);
  gtk_fixed_put (GTK_FIXED (fixed2), label11, 8, 64);
  gtk_widget_set_size_request (label11, 200, 16);
  gtk_label_set_justify (GTK_LABEL (label11), GTK_JUSTIFY_LEFT);

  opcion_archivo = gtk_option_menu_new ();
  gtk_widget_show (opcion_archivo);
  gtk_fixed_put (GTK_FIXED (fixed2), opcion_archivo, 16, 88);
  gtk_widget_set_size_request (opcion_archivo, 264, 24);
  gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivo), FALSE);
  
  /// Aadir al opcion_archivo
  menu1 = gtk_menu_new ();
  
  gtk_option_menu_set_menu (GTK_OPTION_MENU (opcion_archivo), menu1);

  boton_descargar = gtk_button_new ();
  gtk_widget_show (boton_descargar);
  gtk_fixed_put (GTK_FIXED (fixed2), boton_descargar, 152, 120);
  gtk_widget_set_size_request (boton_descargar, 120, 32);
  gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar), FALSE);

  alignment8 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment8);
  gtk_container_add (GTK_CONTAINER (boton_descargar), alignment8);

  hbox8 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox8);
  gtk_container_add (GTK_CONTAINER (alignment8), hbox8);

  image8 = gtk_image_new_from_stock ("gtk-go-down", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image8);
  gtk_box_pack_start (GTK_BOX (hbox8), image8, FALSE, FALSE, 0);

  label10 = gtk_label_new_with_mnemonic ("Descargar");
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (hbox8), label10, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);

  gpointer sid = (int *)gtk_signal_connect(GTK_OBJECT(win_buscar), "delete_event", GTK_SIGNAL_FUNC(cerrar_ventana), NULL);
  
  // Como parametro enviamos el id de la seal delete_event asociada a la ventana
  gtk_signal_connect ((gpointer) boton_efectuar_busqueda, "clicked",
                    G_CALLBACK (busqueda_concreta_clicked),
                    sid);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_buscar, win_buscar, "win_buscar");
  GLADE_HOOKUP_OBJECT (win_buscar, fixed2, "fixed2");
  GLADE_HOOKUP_OBJECT (win_buscar, entrada_archivo, "entrada_archivo");
  GLADE_HOOKUP_OBJECT (win_buscar, label6, "label6");
  GLADE_HOOKUP_OBJECT (win_buscar, boton_efectuar_busqueda, "boton_efectuar_busqueda");
  GLADE_HOOKUP_OBJECT (win_buscar, alignment5, "alignment5");
  GLADE_HOOKUP_OBJECT (win_buscar, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (win_buscar, image5, "image5");
  GLADE_HOOKUP_OBJECT (win_buscar, label7, "label7");
  GLADE_HOOKUP_OBJECT (win_buscar, label11, "label11");
  GLADE_HOOKUP_OBJECT (win_buscar, opcion_archivo, "opcion_archivo");
  GLADE_HOOKUP_OBJECT (win_buscar, boton_descargar, "boton_descargar");
  GLADE_HOOKUP_OBJECT (win_buscar, alignment8, "alignment8");
  GLADE_HOOKUP_OBJECT (win_buscar, hbox8, "hbox8");
  GLADE_HOOKUP_OBJECT (win_buscar, image8, "image8");
  GLADE_HOOKUP_OBJECT (win_buscar, label10, "label10");

  return win_buscar;
}


/**
   Ventana de descarga de archivos
**/
GtkWidget*
create_win_descarga (void)
{
  GtkWidget *win_descarga;
  GtkWidget *fixed3;
  GtkWidget *barra_progreso;
  GtkWidget *etiq_archivo;
  GtkWidget *etiq_estado_descarga;
  GtkWidget *boton_descarga_finalizada;

  win_descarga = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win_descarga), 5);
  gtk_window_set_title (GTK_WINDOW (win_descarga), "Descarga");

  fixed3 = gtk_fixed_new ();
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (win_descarga), fixed3);

  barra_progreso = gtk_progress_bar_new ();
  gtk_widget_show (barra_progreso);
  gtk_fixed_put (GTK_FIXED (fixed3), barra_progreso, 8, 32);
  gtk_widget_set_size_request (barra_progreso, 344, 16);

  // Modificar barra de progreso
  gtk_progress_set_percentage(GTK_PROGRESS(barra_progreso), 0.0);
  //
  
  etiq_archivo = gtk_label_new ("");
  gtk_widget_show (etiq_archivo);
  gtk_fixed_put (GTK_FIXED (fixed3), etiq_archivo, 10, 3);
  gtk_widget_set_size_request (etiq_archivo, 280, 29);
  gtk_label_set_justify (GTK_LABEL (etiq_archivo), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (etiq_archivo), TRUE);

  etiq_estado_descarga = gtk_label_new ("Descargando");
  gtk_widget_show (etiq_estado_descarga);
  gtk_fixed_put (GTK_FIXED (fixed3), etiq_estado_descarga, 8, 56);
  gtk_widget_set_size_request (etiq_estado_descarga, 344, 24);
  gtk_label_set_justify (GTK_LABEL (etiq_estado_descarga), GTK_JUSTIFY_LEFT);

  boton_descarga_finalizada = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_set_sensitive(GTK_WIDGET(boton_descarga_finalizada), FALSE);
  gtk_widget_show (boton_descarga_finalizada);
  gtk_fixed_put (GTK_FIXED (fixed3), boton_descarga_finalizada, 136, 88);
  gtk_widget_set_size_request (boton_descarga_finalizada, 96, 32);
  

  // Cuando cierre la ventana se ejecuta boton_descarga_finalizada
  gtk_signal_connect(GTK_OBJECT(win_descarga), "delete_event", GTK_SIGNAL_FUNC(no_cerrar_ventana), NULL);
  
  g_signal_connect ((gpointer) boton_descarga_finalizada, "clicked",
                    G_CALLBACK (descarga_finalizada_clicked),
                    NULL);
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_descarga, win_descarga, "win_descarga");
  GLADE_HOOKUP_OBJECT (win_descarga, fixed3, "fixed3");
  GLADE_HOOKUP_OBJECT (win_descarga, barra_progreso, "barra_progreso");
  GLADE_HOOKUP_OBJECT (win_descarga, etiq_archivo, "etiq_archivo");
  GLADE_HOOKUP_OBJECT (win_descarga, etiq_estado_descarga, "etiq_estado_descarga");
  GLADE_HOOKUP_OBJECT (win_descarga, boton_descarga_finalizada, "boton_descarga_finalizada");

  return win_descarga;
}

/**
   Ventana buscar usuarios
**/
GtkWidget*
create_win_buscar_usuario (void)
{
  GtkWidget *win_buscar_usuario;
  GtkWidget *fixed4;
  GtkWidget *label15;
  GtkWidget *opcion_usuarios;
  GtkWidget *boton_efectuar_busqueda_usuarios;
  GtkWidget *label16;
  GtkWidget *opcion_archivos2;
  GtkWidget *boton_descargar2;
  GtkWidget *alignment9;
  GtkWidget *hbox9;
  GtkWidget *image9;
  GtkWidget *label17;
  GtkWidget *menu1;
  GtkWidget *menu2;

  win_buscar_usuario = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win_buscar_usuario), 5);
  gtk_window_set_title (GTK_WINDOW (win_buscar_usuario), "Archivos del usuario");

  fixed4 = gtk_fixed_new ();
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (win_buscar_usuario), fixed4);

  label15 = gtk_label_new ("Usuario");
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed4), label15, 16, 16);
  gtk_widget_set_size_request (label15, 41, 16);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);

  opcion_usuarios = gtk_option_menu_new ();
  gtk_widget_show (opcion_usuarios);
  gtk_fixed_put (GTK_FIXED (fixed4), opcion_usuarios, 16, 40);
  gtk_widget_set_size_request (opcion_usuarios, 208, 24);

  /// Aadir al opcion_archivo
  menu1 = gtk_menu_new ();                                                                                                    
  gtk_option_menu_set_menu (GTK_OPTION_MENU (opcion_usuarios), menu1);
  
  boton_efectuar_busqueda_usuarios = gtk_button_new_from_stock ("gtk-find");
  gtk_widget_show (boton_efectuar_busqueda_usuarios);
  gtk_fixed_put (GTK_FIXED (fixed4), boton_efectuar_busqueda_usuarios, 240, 16);
  gtk_widget_set_size_request (boton_efectuar_busqueda_usuarios, 80, 48);

  label16 = gtk_label_new ("Seleccionar archivo a descargar");
  gtk_widget_show (label16);
  gtk_fixed_put (GTK_FIXED (fixed4), label16, 16, 80);
  gtk_widget_set_size_request (label16, 192, 16);
  gtk_label_set_justify (GTK_LABEL (label16), GTK_JUSTIFY_LEFT);

  opcion_archivos2 = gtk_option_menu_new ();
  gtk_widget_show (opcion_archivos2);
  gtk_fixed_put (GTK_FIXED (fixed4), opcion_archivos2, 16, 104);
  gtk_widget_set_size_request (opcion_archivos2, 304, 24);
  gtk_widget_set_sensitive(GTK_WIDGET(opcion_archivos2), FALSE);
  
  /// Aadir al opcion_archivo
  menu2 = gtk_menu_new ();                                                                                                    
  gtk_option_menu_set_menu (GTK_OPTION_MENU (opcion_archivos2), menu2);
  
  boton_descargar2 = gtk_button_new ();
  gtk_widget_show (boton_descargar2);
  gtk_fixed_put (GTK_FIXED (fixed4), boton_descargar2, 192, 136);
  gtk_widget_set_size_request (boton_descargar2, 120, 32);
  gtk_widget_set_sensitive(GTK_WIDGET(boton_descargar2), FALSE);

  alignment9 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment9);
  gtk_container_add (GTK_CONTAINER (boton_descargar2), alignment9);

  hbox9 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER (alignment9), hbox9);

  image9 = gtk_image_new_from_stock ("gtk-go-down", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox9), image9, FALSE, FALSE, 0);

  label17 = gtk_label_new_with_mnemonic ("Descargar");
  gtk_widget_show (label17);
  gtk_box_pack_start (GTK_BOX (hbox9), label17, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label17), GTK_JUSTIFY_LEFT);

  // Cuando cierre la ventana se ejecuta cerrar_ventana
  gtk_signal_connect(GTK_OBJECT(win_buscar_usuario), "delete_event", GTK_SIGNAL_FUNC(cerrar_ventana), NULL);
  
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_buscar_usuario, win_buscar_usuario, "win_buscar_usuario");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, fixed4, "fixed4");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, label15, "label15");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, opcion_usuarios, "opcion_usuarios");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, boton_efectuar_busqueda_usuarios, "boton_efectuar_busqueda_usuarios");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, label16, "label16");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, opcion_archivos2, "opcion_archivos2");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, boton_descargar2, "boton_descargar2");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, alignment9, "alignment9");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, hbox9, "hbox9");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, image9, "image9");
  GLADE_HOOKUP_OBJECT (win_buscar_usuario, label17, "label17");

  return win_buscar_usuario;
}


/**
   Ventana nick: contiene entrada para nick, server (localhost) y puerto (5555)
**/
GtkWidget*
create_win_nick (void)
{
  GtkWidget *win_nick;
  GtkWidget *fixed1;
  GtkWidget *entrada_nick;
  GtkWidget *entrada_server;
  GtkWidget *entrada_puerto;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *acepta_nick;
                                                                                                      
  win_nick = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (win_nick), "Conectar con Nick");
  gtk_window_set_modal (GTK_WINDOW (win_nick), TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (win_nick), 5);
                                                                          
  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (win_nick), fixed1);
                                                                                                      
  entrada_nick = gtk_entry_new ();
  gtk_widget_show (entrada_nick);
  gtk_fixed_put (GTK_FIXED (fixed1), entrada_nick, 5, 30);
  gtk_widget_set_size_request (entrada_nick, 158, 22);
  gtk_entry_set_max_length (GTK_ENTRY (entrada_nick), TAM_NICKS);
  
  entrada_server = gtk_entry_new ();
  gtk_widget_show (entrada_server);
  gtk_fixed_put (GTK_FIXED (fixed1), entrada_server, 5, 80);
  gtk_entry_set_text(GTK_ENTRY(entrada_server), "localhost");
  gtk_widget_set_size_request (entrada_server, 158, 22);
  
  entrada_puerto = gtk_entry_new ();
  gtk_widget_show (entrada_puerto);
  gtk_fixed_put (GTK_FIXED (fixed1), entrada_puerto, 5, 130);
  gtk_entry_set_text(GTK_ENTRY(entrada_puerto), "5555");
  gtk_widget_set_size_request (entrada_puerto, 158, 22);
                                                                                                    
  label1 = gtk_label_new ("Nick");
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 6, 6);
  gtk_widget_set_size_request (label1, 80, 24);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  
  label2 = gtk_label_new ("Servidor");
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed1), label2, 6, 56);
  gtk_widget_set_size_request (label2, 80, 24);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
  
  label3 = gtk_label_new ("Puerto");
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed1), label3, 6, 106);
  gtk_widget_set_size_request (label3, 80, 24);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
                                                                                                      
  acepta_nick = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (acepta_nick);
  gtk_fixed_put (GTK_FIXED (fixed1), acepta_nick, 38, 170);
  gtk_widget_set_size_request (acepta_nick, 96, 32);

  // Cuando cierre la ventana se ejecuta cerrar_ventana
  gtk_signal_connect(GTK_OBJECT(win_nick), "delete_event", GTK_SIGNAL_FUNC(cerrar_ventana), NULL);                                                                              
  
  g_signal_connect ((gpointer) acepta_nick, "clicked",
                    G_CALLBACK (nick_clicked),
                    NULL);
                                                                                                      
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (win_nick, win_nick, "win_nick");
  GLADE_HOOKUP_OBJECT (win_nick, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (win_nick, entrada_nick, "entrada_nick");
  GLADE_HOOKUP_OBJECT (win_nick, entrada_server, "entrada_server");
  GLADE_HOOKUP_OBJECT (win_nick, entrada_puerto, "entrada_puerto");
  GLADE_HOOKUP_OBJECT (win_nick, label1, "label1");
  GLADE_HOOKUP_OBJECT (win_nick, label2, "label2");
  GLADE_HOOKUP_OBJECT (win_nick, label3, "label3");
  GLADE_HOOKUP_OBJECT (win_nick, acepta_nick, "acepta_nick");
  
  return win_nick;
}

