
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <malloc.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "protocolo.h"
#include "files.h"
#include "cola.h"
#include "libclient.h"


void mostrar_opciones_menu ()
{
   printf(" Menu de opciones del cliente: \n");
   printf(" h : Opciones del menu \n");
   printf(" a : Buscar archivo \n");
   printf(" b : Baja del servidor \n");
   printf(" p : Perdir archivo \n");
   printf(" l : Listar los clientes activos en el servidor \n");
   printf(" c : Mostrar todos los ficheros de un cliente concreto \n");
}


/* ------------------- */
/* PROGRAMA PRINCIPAL  */
/* ------------------- */

int main (int argc, char **argv)
{
   int sock, i;
   unsigned int puerto;
   char *nombre_servidor;
   struct sockaddr_in dir_socket_servidor;   // estructura:puerto,@IP,protocolo
   int cliente_activo;
   char nick[TAM_NICKS];
   char *nick_cliente;
   char opcion[10];
   int retorno;
   char nombre_fichero[TAM_NOMBRE_ARCHIVO];
   char ruta_fichero[TAM_NOMBRE_ARCHIVO + 10];
   char busca_fichero[TAM_NOMBRE_ARCHIVO];
   char busca_nick[TAM_NICKS];
   char nick_fichero[TAM_NICKS];
   char *fichero;
   struct TRegistroCompartido *archivo_compartido;
   struct TRegistroCliente *info_cliente;
   unsigned int puerto_filetransfer = FILE_TRANSFER_PORT;
   
   // Obtencion del parametro 'host servidor' y 'puerto'

   if (argc != 3) {
      fprintf(stderr,"Sintaxis: hamster_client host_servidor puerto \n");
      fprintf(stderr,"\t (puerto: valor entre 0 y 65635) \n");
      exit(-1);
   } else {
      nombre_servidor = (char *) malloc (sizeof(char)*50);
      nombre_servidor = argv[1];
      puerto = atoi((char *)argv[2]);
   }
   
   Cola *ficheros = (Cola *)crear_cola();
   if (leer_dir("shared", ficheros) == 1) {
      fprintf(stderr, "Debe existir el directorio shared en el lugar donde se ejecuta la aplicacin!\n");
      fprintf(stderr, "Todo lo que haya dentro de shared ser compartido.\n");
      exit(-1);
   }
   
   // Creacion del socket
   crear_socket(nombre_servidor, puerto, &sock, &dir_socket_servidor);
   
   // Alta del cliente en el servidor
   printf("\n\t ---------------------------- \n");
   printf("\t Servidor de Ficheros HAMSTER \n");
   printf("\t ---------------------------- \n\n");
   printf("-> Bienvenido, introduce tu nick: ");
   scanf("%s",nick);
   
   
   // Inicializamos el socket para la peticiones de archivos de otros clientes
   // Nos devuelve el puerto por donde escuchamos
   puerto_filetransfer = file_transfer_socket();
   // Hacemos un proceso que reciba peticiones de archivos de otros clientes
   int id = fork();
   if (!id) {  // Hijo
      file_transfer_daemon(ficheros);
   }
   
   Alta(sock, dir_socket_servidor, nick, puerto_filetransfer);
   printf("\n-> Has sido correctamente dado de alta en el servidor, %s \n",nick); 
   
   // Los nombres de los ficheros de '/shared' son enviados al servidor para compartirlos
   printf("-> Enviando al servidor los nombres de los ficheros a compartir (/shared) ... \n");
   CompartirFicheros(sock, dir_socket_servidor, nick, ficheros);
   printf("-> Ficheros compartidos enviados correctamente. \n");
   
   Cola *resultados = (Cola *)crear_cola();
   mostrar_opciones_menu();
   cliente_activo = 1;
   while (cliente_activo) {
      printf("\n %s -> ",nick);
      fflush(stdin);
      fflush(stdout);
      scanf("%s",opcion);
      switch(opcion[0]) {
         case 'a':         // Buscar archivo
            printf("\n Introduce el nombre de fichero que deseas buscar: ");
            scanf("%s",busca_fichero);
            retorno = Buscar_archivo(sock,dir_socket_servidor,nick,busca_fichero,resultados);
            if (retorno == 0) {
               printf("\n Se han encontrado las siguientes coincidencias con %s : \n",busca_fichero);
               printf("\n ** NICK ** || ** FICHERO ** \n");
               printf(" --------------------------- \n");
               reiniciar_PDI(resultados);
               archivo_compartido = (struct TRegistroCompartido *)obtener_elemento_PDI(resultados);
               while (archivo_compartido != NULL) {
                  printf("\n %s",archivo_compartido -> nick);
                  for (i = strlen(nick); i < TAM_NICKS + 4; i++) {
                     printf(" ");
                  }
                  printf("%s",archivo_compartido -> archivo);
                  avanzar_PDI(resultados);
                  archivo_compartido = (struct TRegistroCompartido *)obtener_elemento_PDI(resultados);
               }
               printf("\n");
               vaciar_cola(resultados);
            }
            else if (retorno == 2) {
               printf("\n No se ha encontrado ninguna coincidencia de %s en el sevidor ! ",busca_fichero);
            }
            else {
               printf("\n Error en la busqueda del archivo en el servidor ! ");
            }
            break;
         
         case 'b':         // Baja servidor
            cliente_activo = 0;
            Baja(sock, dir_socket_servidor, nick);
            break;
         
         case 'l':         // Listado usuarios
            retorno = Listar_usuarios(sock, dir_socket_servidor, nick, resultados);
            if (retorno == 0) {
               reiniciar_PDI(resultados);
               printf(" Usuarios activos en el Servidor de Ficheros HAMSTER: \n");
               printf("\n ** NICK ** \n");
               printf(" ----------  \n");
               nick_cliente = (char *)obtener_elemento_PDI(resultados);
               while (nick_cliente != NULL) {
                  printf("\n %s",nick_cliente); 
                  avanzar_PDI(resultados);
                  nick_cliente = (char *)obtener_elemento_PDI(resultados);
               }
               printf("\n");
               vaciar_cola(resultados);
            }
            else if (retorno == 2) {
               printf("\n No hay ningun usuario activo en el servidor ! ");               
            }
            else {
               printf("\n Error en la consulta al servidor de los usuarios activos ! ");               
            }
            break;
         
         case 'p':         // Pedir fichero
            printf("\n Introduce el fichero a pedir: ");
            scanf("%s",nombre_fichero);
            printf("\n Introduce el nick del propietario del fichero: ");
            scanf("%s",&nick_fichero[0]);
            sprintf(&ruta_fichero[0],"shared/");
            strcat(ruta_fichero,nombre_fichero);
            int id_peticion = fork();
            if (!id_peticion) {  // Proceso hijo encargado de recibir el fichero
               info_cliente = (struct TRegistroCliente *)malloc(sizeof (struct TRegistroCliente));
               Consultar_datos_cliente(sock,dir_socket_servidor,nick,nick_fichero,info_cliente);
               if (pedir_archivo(info_cliente->ip, atoi(info_cliente->puerto), ruta_fichero) != 0) {
                  fprintf(stderr, "\n No se ha podido obtener el archivo %s ! ",nombre_fichero);
               }
               else {
                  printf("\n Aviso: Ha finalizado correctamente la transferencia del fichero %s",nombre_fichero);
               }
               return 0;
            }
            break;
         
         case 'c':         // Listado ficheros cliente
            printf("\n Introduce el nick del cliente a consultar: ");
            scanf("%s",busca_nick);
            retorno = Listar_archivos_cliente(sock,dir_socket_servidor,nick,busca_nick,resultados);
            if (retorno == 0) {
               reiniciar_PDI(resultados);
               printf("\n Ficheros compartidos del cliente %s : \n",busca_nick);
               printf("\n ** FICHERO ** \n");
               printf(" -------------  \n");
               fichero = (char *)obtener_elemento_PDI(resultados);
               while (nombre_fichero != NULL) {
                  printf("\n %s",fichero); 
                  avanzar_PDI(resultados);
                  fichero = (char *)obtener_elemento_PDI(resultados);
               }
               printf("\n");
               vaciar_cola(resultados);
            }
            else if (retorno == 2) {
               printf("\n El cliente solicitado no tiene ningun fichero compartido ! ");
            }
            else {
               printf("\n Error en la consulta al servidor de los ficheros de %s ! ",busca_nick);               
            }
            break;            
         
         case 'h':         // Mostrar ayuda
            mostrar_opciones_menu();
            break;
         
         default:
            printf("\n %s -> Opcion incorrecta! %c",nick,opcion[0]);
            break;
      }
   }
   printf("\n%s desconectado del servidor de ficheros HAMSTER. \n",nick);
   printf("Hasta pronto! \n\n");
   
   // Enviamos seal al demonio de transferencia de archivos para que pare
   kill(id, SIGINT);
   wait(&id);
   
   // Cerramos sockets
   if ((close(sock))==-1) { 
      fprintf(stderr, "Error Cliente:close"); 
      perror((char *)close); 
   }
   
   return 0;
}


