
#ifndef PROTOCOLO_H
#define PROTOCOLO_H
   
   #define TAM_NOMBRE_SERVIDOR 100
   #define TAM_NOMBRE_ARCHIVO 200
   #define MAX_RESULTADOS 50
   
   /* ------------------------------------------------------------- */
   /* Estructuras para la comunicacion de los clientes al servidor  */ 
   /* ------------------------------------------------------------- */
   
   #define ALTA_EN_SERVIDOR 1
   #define COMPARTIR_FICHERO 2
   #define BAJA_EN_SERVIDOR 3
   #define CONSULTA_FICHEROS_SERVIDOR 4
   #define MOSTRAR_USUARIOS_ACTIVOS 5
   #define CONSULTA_FICHEROS_USUARIO 6
   #define CONSULTA_DATOS_USUARIO 7
   #define FILE_TRANSFER_PORT 9696
   #define TAM_NICKS 10
   
   #undef DEBUG
   //#define DEBUG
   
   struct Tipo_Cabecera
   {
      unsigned int accion;
      char nick[TAM_NICKS];
   };
   typedef struct Tipo_Cabecera Cabecera;
   

   struct Tipo_CabeceraAlta
   {
      unsigned int accion;
      char nick[TAM_NICKS];
      unsigned int puerto;
   };
   
   struct TInfoFichero {
      unsigned int accion;
      char nick[TAM_NICKS];
      char nombre[TAM_NOMBRE_ARCHIVO];
   };
   
   // Longitud mxima de IP: 16 y de Archivos: 200
   struct TRegistroCompartido {
      char nick[TAM_NICKS];
      char archivo[TAM_NOMBRE_ARCHIVO];
   };
   
   struct TRegistroCliente {
      char ip[16];
      char puerto[6];
   };
   
   struct TInfoUsuario {
      unsigned int accion;
      char nick[TAM_NICKS];
      char nick_interes[TAM_NICKS];
   };
   
   #define TAM_CABECERA sizeof(Cabecera)
#endif
